/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

class ProgressIndicator : public IProgressIndicator {
	QProgressBar * pBar;
public:
	ProgressIndicator (QProgressBar * pb)
		: pBar (pb)
	{
	}
	
	virtual void setProgress (int p) {
		pBar->setProgress (p);
	}
};

void BibleForm::init () {
/*	QProgressBar pbar (100, statusBar());
	pbar.show();
	statusBar()->message ("   ...");
	statusBar()->addWidget (&pbar, 10, TRUE);
*/
	try {
		//ProgressIndicator pInd (&pbar);
		bible = new CBible ("CompactText.bin"); //, &pInd);
	/*	
		for (int i = 0; i < 100; i++) {
			pInd.setProgress (i);
			long x;
			for (long j = (0); j > -1; j++)
				x++;
		}
	*/
	} catch (EBible & ex) {
		QMessageBox::critical (this, "", ex.what(), "  !");
		QApplication::exit (-1);
	}
	/*
	statusBar()->removeWidget (&pbar);
	statusBar()->clear();
*/
	
	bookCombo_activated (0);
}

void BibleForm::destroy() {
	delete bible;
}

void BibleForm::bookCombo_activated( int bookN )
{
	//QMessageBox::information (this, "alert", "bookCombo_activated()", "OK");
	int chapters = (*bible)[bookN].size();
	//QMessageBox::information (this, "chapters=", QString::number(chapters), "OK");

	int chapN = chapterCombo->currentItem();
	chapterCombo->clear();
	for (int i = 1; i <= chapters; i++) {
		chapterCombo->insertItem (QString::number(i));
	}

    int ch =  (chapN < chapters) ? chapN : chapters - 1;
	chapterCombo->setCurrentItem (ch);
	chapterCombo_activated (ch);
}

void BibleForm::chapterCombo_activated( int chapterN )
{
	//QMessageBox::information (this, "alert", "chapterCombo_activated()", "OK");
	int bookN = bookCombo->currentItem();
	int verses = (*bible)[bookN][chapterN].size();
	//QMessageBox::information (this, "verses=", QString::number(verses), "OK");
	
    int verseN = verseCombo->currentItem();
	verseCombo->clear();
	for (int i = 1; i <= verses; i++) {
		verseCombo->insertItem (QString::number(i));
	}
    
	int v = (verseN < verses) ? verseN : verses - 1;
	verseCombo->setCurrentItem (v);
   	verseCombo_activated (v);
}


void BibleForm::verseCombo_activated( int verseN )
{
	//QMessageBox::information (this, "alert", "verseCombo_activated()", "OK");
	int bookN = bookCombo->currentItem();
	int chapterN = chapterCombo->currentItem();
	goToRef (CRef (bookN+1, chapterN+1, verseN+1));
}


void BibleForm::searchEdit_returnPressed()
{
	searchButton_pressed();
}


void BibleForm::searchButton_pressed()
{
	if (searchEdit->text().isEmpty()) {
		QMessageBox::information (this, "", ",        ", "OK");
		return;
	}

	bible->search ((const char*)searchEdit->text(), searchResults, wholeWordCheck->isChecked());
	searchResultsList->clear();
	for (size_t i = 0; i < searchResults.size(); i++)
		searchResultsList->insertItem (searchResults[i].toString());
}


void BibleForm::searchResultsList_highlighted(int i)
{
	goToRef(searchResults[i]);
}

void BibleForm::fileExit_activated()
{
	this->close();
}

void BibleForm::helpAbout_activated()
{
	QMessageBox::about (this, " ?", 
							  "   Linux 0.3 alpha\n"
							   ":  , 2005\n"
							   "Email: rsdevelop@gmail.com\n");
}


void BibleForm::goToRef( const CRef & ref )
{
	static bool lock = false;
	if (lock) return;
	lock = true;

	int bookN = ref.bookNum - 1;
	if (bookN != bookCombo->currentItem()) {
		bookCombo->setCurrentItem(bookN);
        bookCombo_activated (bookN);
    }
	
	int chapterN = ref.chapter - 1;
	if (chapterN != chapterCombo->currentItem()) {
		chapterCombo->setCurrentItem (chapterN);
        chapterCombo_activated (chapterN);
	}
    
	int verseN = ref.verse - 1;
	if (verseN != verseCombo->currentItem())
		verseCombo->setCurrentItem (verseN);
	
	const CChapter & chapter = (*bible)[bookN][chapterN];
	
	textRichEdit->clear();
	for (int v = 0; v < (int)chapter.size(); v++) {
		QString verseText = QString("[") + QString::number(v+1) + "] ";
		verseText += chapter[v].getText(); 
		
		QColor prevColor;
		if (v == verseN) {
			prevColor = textRichEdit->color();
			textRichEdit->setColor (QColor("red"));
		}
			
		//textRichEdit->insertParagraph (verseText, -1);
		textRichEdit->append (verseText);
		
		if (v == verseN)
			textRichEdit->setColor (prevColor);
	}
	QRect activeRect = textRichEdit->paragraphRect (verseN);
	textRichEdit->ensureVisible (activeRect.x(), activeRect.y(), 50, 0);
	
	lock = false;
}



void BibleForm::helpAboutQt_activated()
{
	QMessageBox::aboutQt (this, "   Linux 0.3 alpha");
}

void BibleForm::helpWhatsThis_activated()
{
	whatsThis();
}
